
Core - Task # 55122

Epic # 55070 (Accepted): Workpackages
Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)
Story # 55078 (Closed): Optimize PHP code performance in TYPO3 methods

Status: Resolved Priority: Should have
Author: Michiel Roos Category: Performance
Created: 2014-01-18 Assigned To: Michiel Roos
Updated: 2014-02-01 Due date:
TYPO3 Version: 6.2
PHP Version: 5.3
Complexity: medium
Sprint Focus:
Subject: Cleanup and optimize methods in ExtensionManagementUtility
Description

Methods in ExtenstionManagementUtility are called a lot. We need to ensure they are as performant as possible.

    -  Reduce function calls
    -  Use language constructs instead of functions
    -  Use language constructs to check values before calling a function
    -  Return early where possible
    -  Rewrite addToAllTCAtypes() to just do a few preg_replace() calls and not call all the child methods

Related issues:
related to Core - Bug # 55662: PHP Warning preg_replace in current master Resolved 2014-02-04

Associated revisions
Revision aa37842b - 2014-02-01 13:32 - Michiel Roos

[CLEANUP] Cleanup ExtensionManagementUtility
Methods in this class are called a lot and are in need of some cleanup.
    -  return early
    -  reduce method and function calls
    -  update doc comments
    -  added tests with data provider for Method getCN

Change-Id: I5dcab647fc3da078b5f29beb57fecbf7c98bcaa5
Resolves: #55122
Releases: 6.2
Reviewed-on: https://review.typo3.org/27019
Reviewed-by: Andreas Wolf
Tested-by: Andreas Wolf

Revision 707b0106 - 2014-02-03 23:35 - Michiel Roos

[BUGFIX] addModule after/before not working

The cleaned up addModule() method no longer adds the module after a
module, when the target module does not exist.
Expected behaviour: module added to the list.

Observed behaviour: module not added at all.

Change-Id: Ie0d1d0c98f9c7dde81636a40eb18a3a7816392f6
Resolves: #55608
Related: #55122
Releases: 6.2
Reviewed-on: https://review.typo3.org/27284
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn
Reviewed-by: Markus Klein
Tested-by: Markus Klein

History
#1 - 2014-01-22 09:55 - Michiel Roos

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::executePositionedStringInsertion()
http://pastebin.com/UbMrdUL4

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::executePositionedStringInsertion()
http://pastebin.com/UbMrdUL4

#2 - 2014-01-23 11:25 - Michiel Roos

/typo3/backend.php
https://www.evernote.com/shard/s32/sh/c873dbf2-ec07-45a9-b031-9085a87c2d34/2a1e97e051890501b747ff738fd254dc

#3 - 2014-01-23 11:29 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27019

#4 - 2014-01-28 10:19 - Ernesto Baschny
- Parent task set to #55078

#5 - 2014-01-31 15:09 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27019

#6 - 2014-01-31 18:31 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27019
#7 - 2014-01-31 23:25 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27019

#8 - 2014-01-31 23:26 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27019

#9 - 2014-02-01 13:32 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27019

#10 - 2014-02-01 14:30 - Michiel Roos
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:aa37842bd4468c9313bd98c97d6d2d76ad44e6b5.
